import React, { useEffect, useRef, useState } from "react";
import {
  createStackNavigator,
  TransitionPresets,
} from "@react-navigation/stack";
import { getStationList2 } from "./lib/getStationList2";
import Apps from "./Apps";
import TrainBase from "./trainbaseview";
import HowTo from "./howto";
import News from "./components/news.js";
import TrainMenu from "./components/trainMenu.js";
import FavoriteList from "./components/FavoriteList.js";
import { optionData } from "./lib/stackOption.js";
import { useNavigation } from "@react-navigation/native";
const Stack = createStackNavigator();
export const Top = () => {
  const navigation = useNavigation();
  const { navigate, addListener } = navigation;
  //地図用
  const [mapsStationData, setMapsStationData] = useState(undefined);

  useEffect(() => {
    getStationList2().then(setMapsStationData);
  }, []);

  useEffect(() => {
    const unsubscribe = addListener("tabLongPress", (e) =>
      navigate("favoriteList")
    );

    return unsubscribe;
  }, [navigation]);

  return (
    <Stack.Navigator>
      <Stack.Screen
        name="Apps"
        options={{
          headerShown: false,
          gestureEnabled: true,
          headerTransparent: true,
        }}
        children={() => <Apps stationData={mapsStationData} />}
      />
      <Stack.Screen
        name="trainbase"
        options={{
          title: "トレインビジョン",
          gestureEnabled: true,
          ...TransitionPresets.SlideFromRightIOS,
        }}
        component={TrainBase}
      />

      <Stack.Screen name="howto" options={optionData} component={HowTo} />
      <Stack.Screen name="news" options={optionData} component={News} />

      <Stack.Screen
        name="trainMenu"
        options={optionData}
        children={() => <TrainMenu stationData={mapsStationData} />}
      />

      <Stack.Screen
        name="favoriteList"
        options={{ ...optionData, gestureEnabled: false }}
        children={() => <FavoriteList stationData={mapsStationData} />}
      />
    </Stack.Navigator>
  );
};
